diff --git a/host/apdu_split.c b/host/apdu_split.c
index f2cfb7a..0348e46 100644
--- a/host/apdu_split.c
+++ b/host/apdu_split.c
@@ -29,6 +29,8 @@
 
 #include "apdu_split.h"
 
+#include <osmocom/core/utils.h>
+
 enum iso7816_apdu_state {
 	APDU_S_CLA,
 	APDU_S_INS,
@@ -175,6 +177,7 @@ void apdu_split_boundary(struct apdu_split *as)
 
 void apdu_split_in(struct apdu_split *as, uint8_t *buf, int len)
 {
+	printf("apdu_split_in() reached, buf: %s\n", osmo_hexdump(buf, len));
 	while (len--)
 		apdu_split_inbyte(as, *buf++);
 }
diff --git a/host/main.c b/host/main.c
index 4fbac8d..c74da7f 100644
--- a/host/main.c
+++ b/host/main.c
@@ -92,6 +92,7 @@ static int process_usb_msg(uint8_t *buf, int len)
 	
 	switch (sh->cmd) {
 	case SIMTRACE_MSGT_DATA:
+		printf("process_usb_msg(), payload: %s\n", osmo_hexdump(payload, payload_len));
 		/* special treatment for ATR */
 		if (sh->flags & SIMTRACE_FLAG_ATR) {
 			printf("ATR ");
@@ -204,6 +205,7 @@ int main(int argc, char **argv)
 		}
 		if (xfer_len > 0) {
 			//printf("URB: %s\n", osmo_hexdump(buf, rc));
+			printf("main(), buf: %s\n", osmo_hexdump(buf, xfer_len));
 			process_usb_msg(buf, xfer_len);
 			msg_count++;
 			byte_count += xfer_len;
